diff -r d0e39ec4f23f src/event/ngx_event_openssl.c
--- a/src/event/ngx_event_openssl.c	Tue Sep 16 16:23:19 2014 +0400
+++ b/src/event/ngx_event_openssl.c	Mon Sep 29 14:00:51 2014 +0530
@@ -304,8 +304,6 @@
         return NGX_ERROR;
     }
 
-    X509_free(x509);
-
     /* read rest of the chain */
 
     for ( ;; ) {
@@ -2576,6 +2574,9 @@
 {
     ngx_ssl_t  *ssl = data;
 
+    /* Free the cert set using SSL_CTX_set_ex_data earlier */
+    X509 *cert = SSL_CTX_get_ex_data(ssl->ctx, ngx_ssl_certificate_index);
+    if (cert) { X509_free(x509); }
+
     SSL_CTX_free(ssl->ctx);
 }
 
